/// \file
/// \author Gerald Fahrnholz

#pragma once

#include "CommonSources/CommonDefinitions.h"

///\cond do not document


namespace TestToolBox
{
    //-----------------------------------------------------------------------------

    TTB_INLINE std::string StringFuncEmpty()
    {
        // do nothing

        // return empty string
        return std::string();
    }

    //-----------------------------------------------------------------------------

    TTB_INLINE std::string  ExtractFunctionName(std::string const & in_ppFuncName)
    {
        std::size_t pos = in_ppFuncName.find_last_of(":");
        if (pos == std::string::npos)
        {
            return in_ppFuncName;
        }
        else
        {
            return in_ppFuncName.substr(pos+1);
        }
    }

    //-----------------------------------------------------------------------------

    TTB_INLINE std::string  ExtractClassName(std::string const & in_ppFuncName)
    {
        std::string className;
        std::size_t pos = in_ppFuncName.find_last_of(":");
        if (pos != std::string::npos)
        {
            std::size_t posClassName =  in_ppFuncName.find_last_of(":",pos-2);
            if (posClassName == std::string::npos)
            {
                posClassName = -1;
            }
            className = in_ppFuncName.substr(posClassName+1,pos-2-posClassName);
        }
        return className;
    }

    //-----------------------------------------------------------------------------

}; // namespace TestToolBox

///\endcond
