////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 
/// \brief
/// Allows optional suppressing of windows header using define TTB_NO_WINDOWS_HEADER
/// 
////////////////////////////////////////////////////////////////////////////////

#pragma once

///\cond do not document

// allow explicit include of windows header outside of the test environment
#ifndef TTB_NO_WINDOWS_HEADER

#ifndef NOMINMAX

#define NOMINMAX    // we don't want windows to override std::min and std::max with macros
#include <windows.h>

#endif

#endif

///\endcond
