////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 

#pragma once

#include <string>

namespace TestToolBox
{
    class RegisteredSimulatedObject;

    /// Namespace supporting shorter names for accessing services of testing framework
    /// Recom mendation: within your test script specify: using TestToolBox::ShortNames.
    namespace ShortNames
    {
        RegisteredSimulatedObject* SimObject(std::string const & in_objectName);

        /// Short form for TestEvents::Get()->Act()
        void Act(const char* in_actualEvent, ...);

        /// Short form for MyErrorEvents::Get()->ReportStoredErrors();
        void ReportStoredErrors(void);

        /// Short form for MyErrorEvents::Get()->DeleteStoredErrors();
        void DeleteStoredErrors(void);

        /// \brief Short form for MyErrorEvents::Get()->SetNotificationActionForErrorMsgNum(
        /// msgNum, ACTION_IGNORE/ACTION_NOT_SPECIFIED);
        void SetIgnoreError(
            long in_errorMsgNum,
            bool in_ignore);

        /// \brief Short form for MyErrorEvents::Get()->IgnoreErrorContainingTextPattern()
        void IgnoreErrorContainingTextPattern(
            std::string const & in_text);

        /// \brief Short form for MyErrorEvents::Get()->ClearStoredTextPatterns()
        void ClearStoredErrorTextPatterns(void);

        /// \brief Short form for MyErrorEvents::Get()->SetErrorSync()
        void SetErrorSync(
            bool in_syncOnError);

        /// \brief Short form for MyErrorEvents::Get()->SetImmediateErrorLog()
        void SetImmediateErrorLog(
            bool in_immediateLog);

        /// \brief Short form for MyErrorEvents::Get()->ErrorOk()
        bool ErrorOk(long in_extErrorId);

    }
}
