////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 
/// \brief
/// Interface ISimpleObject with callback ICallBackFromSimpleObject is used within the
/// demo test aplication
/// 
////////////////////////////////////////////////////////////////////////////////

#pragma once
///\cond do not document

// Calback interface
struct ICallBackFromSimpleObject
{
	// Used for synchronous and asynchronous callbacks
	virtual void Result(
		long in_value) = 0;
};

// Interface to the object under test
struct ISimpleObject
{
	// Establishes connection using custom callback interface
	virtual void Connect(
		ICallBackFromSimpleObject* in_pICallBack) = 0;

	// Returns result of calculation via synchronous callback
	virtual void CalcSync(
		long in_val) = 0;

	// Returns result of calculation via asynchronous callback
	virtual void CalcAsync(
		long in_val) = 0;
};

///\endcond do not document
