// TestFilter.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "../../Filter.h"
#include <iostream>
#include <vector>

//-----------------------------------------------------------------------------


using namespace TestToolBox;

std::vector<std::string> testData = {
	"Hugo, Anna",
	"Hugo, Anna, Otto, Felix",
	"Peter, Otto, Hugo, Anna",
	"Peter, Felix, Anna, Julia",
	"Hugo, Felix, Anna, Julia"
};

//-----------------------------------------------------------------------------

#define TEST_MATCH(filter) TestMatch(filter, #filter);

void TestMatch(FilterSp spFilter, std::string const & in_nameFilter)
{
	std::cout << std::endl;

	for (auto const & text : testData)
	{
		std::cout << in_nameFilter.c_str()
			<< (spFilter->Matches(text) ? "     Matched " : " Not Matched ")
			<< text.c_str() << std::endl;
	}
}

//-----------------------------------------------------------------------------

int _tmain(int argc, _TCHAR* argv[])
{
	FilterSp spFilterHugoAndNotOtto                 = Match("Hugo") & !Match("Otto");
	FilterSp spFilterHugoAndNotOtto_Or_HugoAndPeter = (Match("Hugo") & !Match("Otto")) | (Match("Hugo") & Match("Peter"));
	FilterSp spFilterHugoXorFelix                   = Match("Hugo") ^ Match("Felix");
	FilterSp spFilterHugoAndNotOtto_Or_HugoXorFelix = Match(spFilterHugoAndNotOtto) | Match(spFilterHugoXorFelix);

	TEST_MATCH(spFilterHugoAndNotOtto);
	TEST_MATCH(spFilterHugoAndNotOtto_Or_HugoAndPeter);
	TEST_MATCH(spFilterHugoXorFelix);
	TEST_MATCH(spFilterHugoAndNotOtto_Or_HugoXorFelix);

	return 0;
}

