////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 
/// \brief
/// Class CallBackFromSimpleObjectis a call back object with interface
/// ICallBackFromSimpleObject to receive calls from SimpleObject.
/// 
////////////////////////////////////////////////////////////////////////////////

#pragma once


#include "SourcesToTest\ISimpleObject.h" // ICallBackFromSimpleObject
#include "TestToolBox/Synchronizer.h"   // synchronization via TU_SYNC
#include "TestToolBox/TestEvents.h"     // signalling (asynchronous) textual events
#include "TestToolBox/SimulatedObjectBase.h" // basic support for typical tasks of a simulated object

using namespace TestToolBox;

///\cond do not document

class CallBackFromSimpleObject :
    public ICallBackFromSimpleObject, public RegisteredSimulatedObject
{
public:

    // Constructor
    explicit CallBackFromSimpleObject(
        bool in_generateSyncEvent = true);

    // Destructor
    virtual ~CallBackFromSimpleObject(){};

    //********************************************************************
    // Interface ICallBackFromSimpleObject
    //********************************************************************

    void Result (long in_val);

    int SpecialResultA(
        long in_value, long& out_value);
    int SpecialResultB(
        long in_value, long& out_value);
    int SpecialResultC(
        long in_value, long& out_value);
    int SpecialResultD(
        long in_value, long& out_value);
    int SpecialResultE(
        long in_value, long& out_value);
    int SpecialResultF(
        long in_value, long& out_value);
    int SpecialResultG(
        long in_value, long& out_value);
    SomeErrorResult CallBackFromSimpleObject::SpecialResultH(
        long in_value, long& out_value);

}; // class CallBackFromSimpleObject

///\endcond do not document
