#pragma once

////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 
/// \defgroup GrpExampleDll ExampleDll
/// @{
/// \ingroup GrpTestEnvWithMultipleDlls
/// \brief
/// "ExampleDll.dll" is a simple Win32 DLL that demonstrates the usage of some of the test
/// utilities from within a DLL.
///
///
/// The exported methods AccessEnvironmentWithinExampleDll() and AccessTestEventsWithinExampleDll()
/// atre called from the main test aplication TestEnvWithMultipleDlls.
///
/// \sa ExampleDll.h (File documentation)
/// \sa GrpTestEnvWithMultipleDlls (test app)
///
////////////////////////////////////////////////////////////////////////////////

/// \cond

#ifdef EXAMPLEDLL_EXPORTS
#define EXAMPLE_DLL_API __declspec(dllexport)
#else
#define EXAMPLE_DLL_API __declspec(dllimport)
#ifdef NDEBUG
#pragma comment( lib, "ExampleDll" )
#else
#pragma comment( lib, "ExampleDllD" )
#endif
#endif


EXAMPLE_DLL_API
void AccessEnvironmentWithinExampleDll (void);

EXAMPLE_DLL_API
void AccessTestEventsWithinExampleDll (void);

/// \endcond

///@} // end group GrpExampleDll
