#include "stdafx.h"
#include "MyTestCommands.h"
#include <pugixml.hpp>
#include <TestToolBox\TestToolBox.h>

namespace TTB = TestToolBox;

//-----------------------------------------------------------------------------

void InitialPreparation()
{
	TTB_TEST_CASE("Initial preparation, create XML sample file from const xml string and check all contents");

	//-------------------------------------------------------------------------
	TTB_SECTION("Store std string with XML data as XML file");
	//-------------------------------------------------------------------------

	// Read XML string into XML document structure
	pugi::xml_document docFromString;
	TTB::TheXmlCheck()->ReadFromString(docFromString, DEMO_XML_STRING);

	// Save XML document to file
	bool saveSucceeded = TTB::TheXmlCheck()->SaveToFile(docFromString, MY_XML_FILE_PATH);
	assert(saveSucceeded);

	//-------------------------------------------------------------------------
	TTB_SECTION("Read file again and check all file contents in detail");
	//-------------------------------------------------------------------------

	pugi::xml_document docFromFile;
	TTB::TheXmlCheck()->ReadFromFile(docFromFile, MY_XML_FILE_PATH);
	TTB::TheXmlCheck()->CheckNode(docFromFile);
	TTB_EXP("MyContainer");
	TTB_EXP("  Group_A");
	TTB_EXP("    Vector");
	TTB_EXP("      id: 1");
	TTB_EXP("      date: 01.07.09");
	TTB_EXP("      time: 09:15:12.234");
	TTB_EXP("      tolerance: 0.0258");
	TTB_EXP("      This is the text of the first vector element");
	TTB_EXP("      x");
	TTB_EXP("        3.14235");
	TTB_EXP("    Vector");
	TTB_EXP("      id: 2");
	TTB_EXP("      date: 01.07.09");
	TTB_EXP("      time: 09:15:12.234");
	TTB_EXP("      tolerance: 0.0375451");
	TTB_EXP("      This is the text of the second vector element");
	TTB_EXP("      x");
	TTB_EXP("        3.14235");
	TTB_EXP("    Vector");
	TTB_EXP("      id: 3");
	TTB_EXP("      tolerance: 1.357");
	TTB_EXP("      x");
	TTB_EXP("        6.28532");
	TTB_EXP("  Group_B");
	TTB_EXP("    x");
	TTB_EXP("      1.23456");
	TTB_EXP("    x");
	TTB_EXP("      2.3581");
	TTB_EXP("    x");
	TTB_EXP("      3.132437");
	TTB_EXP("    x");
	TTB_EXP("      4.987654");
	TTB_EXP("    x");
	TTB_EXP("      5.29741");
	TTB_EXP("  Group_C");
	TTB_EXP("    Interior");
	TTB_EXP("      Something");
	TTB_EXP("        Some text");
	TTB_EXP("      date");
	TTB_EXP("        28.09.09");
	}

//-----------------------------------------------------------------------------
