////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 
/// \brief
/// Declaration of all relevant classes of TestToolBox
/// 
////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "ConditionalFixture.h"
#include "Environment.h"
#include "ErrorEvents.h"
#include "Protocol.h"
#ifdef TTB_USE_RUNNER
#include "Runner.h"
#endif
#include "ShortNames.h"
#include "Synchronizer.h"
#include "TestEvents.h"
#include "TestTime.h"

#if defined(TTB_USE_TINY_XML) || defined(TTB_USE_PUGI_XML)
#include "XmlCheck.h"
#endif

#ifdef TTB_USE_BOOST_TEST
// avoid already defined link error (is there a better solution?)
//#define init_unit_test_suite init_auto_unit_test_suite
#include "ExtensionsForBoostTest/BoostDefaultTestEnvironment.h"
#include <boost/test/unit_test.hpp>
#endif
