////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 
/// \brief
/// Implementation of complete TestToolBox
/// 
////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "TestToolBox.h"
#include "./CommonDefinitionsImpl.h"
#ifdef TTB_USE_RUNNER
#include "RunnerImpl.h"
#endif
#include "ConditionalFixtureImpl.h"
#include "EnvironmentImpl.h"
#include "ErrorEventsImpl.h"
#include "TestEventsImpl.h"
#include "ProtocolImpl.h"
#include "PerformanceDataSetImpl.h"
#include "SimulatedObjectBaseImpl.h"
#include "ShortNamesImpl.h"
#include "SynchronizerImpl.h"
#include "TestStreamImpl.h"
#include "TestTimeImpl.h"
#include "WaitableConditionImpl.h"
#include "SimulatedObjectBaseImpl.h"
#include "WaitableConditionImpl.h"


// XmlCheck requires use of the following define
// and assumes lib TinyXPath_lib is available
#if defined(TTB_USE_TINY_XML) || defined(TTB_USE_PUGI_XML)
    #include "XmlCheckImpl.h"
#endif

#ifdef TTB_USE_BOOST_TEST
#include "ExtensionsForBoostTest/BoostDefaultTestEnvironmentImpl.h"
#endif
