////////////////////////////////////////////////////////////////////////////////
///
/// \file
/// \author Gerald Fahrnholz
/// 
////////////////////////////////////////////////////////////////////////////////

#pragma once

#include <map>

namespace HandleType
{
	enum Enum {UNKNOWN, PROCESS, PIPE_STD_OUT};
}

struct EventInfo
{
	EventInfo (
		HandleType::Enum in_type,
		HANDLE           in_handle)

		: type (in_type)
		, handle (in_handle)
		, active (true)
	{
	}

	EventInfo ()
		: type (HandleType::UNKNOWN)
		, handle (0)
		, active (false)
	{
	}

	void SetFinished()
	{
		active = false;
	}

	HandleType::Enum type;
	HANDLE           handle;
	bool             active;
};

typedef std::map<HANDLE,EventInfo> EventInfoMap;
